## debian-cd 2.2.13

=== Makefile ===
#!/usr/bin/make -f

# Main Makefile for YACS
#
# Copyright 1999 Raphal Hertzog <hertzog@debian.org>
# See the README file for the license

# The environment variables must have been set
# before. For this you can source the CONF.sh 
# file in your shell


## DEFAULT VALUES
ifndef VERBOSE_MAKE
Q=@
endif
ifndef SIZELIMIT
SIZELIMIT=$(shell echo -n $$[ 610 * 1024 * 1024 ])
endif
ifndef TASK
TASK=$(BASEDIR)/tasks/Debian_$(CODENAME)
endif
ifndef CAPCODENAME
CAPCODENAME:=$(shell perl -e "print ucfirst("$(CODENAME)")")
endif
ifndef BINDISKINFO
BINDISKINFO="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num ($$DATE)"
endif
ifndef SRCDISKINFO
SRCDISKINFO="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num ($$DATE)"
endif
# ND=No-Date versions for README
ifndef BINDISKINFOND
BINDISKINFOND="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num"
endif
ifndef SRCDISKINFOND
SRCDISKINFOND="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num"
endif
ifndef BINVOLID
ifeq ($(ARCH),powerpc)
BINVOLID="Debian $(DEBVERSION) ppc Bin-$$num"
else
BINVOLID="Debian $(DEBVERSION) $(ARCH) Bin-$$num"
endif
endif
ifndef SRCVOLID
SRCVOLID="Debian $(DEBVERSION) Src-$$num"
endif
ifndef MKISOFS
export MKISOFS=/usr/bin/mkisofs
endif
ifndef MKISOFS_OPTS
#For normal users
MKISOFS_OPTS=-r -T
#For symlink farmers
#MKISOFS_OPTS=-r -F . -T
endif
ifndef HOOK
HOOK=$(BASEDIR)/tools/$(CODENAME).hook
endif
ifndef BOOTDISKS
export BOOTDISKS=$(MIRROR)/dists/$(CODENAME)/main/disks-$(ARCH)
endif
ifndef DOJIGDO
export DOJIGDO=0
endif

## Internal variables  
apt=$(BASEDIR)/tools/apt-selection
list2cds=$(BASEDIR)/tools/list2cds
cds2src=$(BASEDIR)/tools/cds2src
master2tasks=$(BASEDIR)/tools/master2tasks
mirrorcheck=$(BASEDIR)/tools/mirror_check
add_packages=$(BASEDIR)/tools/add_packages
add_dirs=$(BASEDIR)/tools/add_dirs
add_bin_doc=$(BASEDIR)/tools/add-bin-doc
scanpackages=$(BASEDIR)/tools/scanpackages
scansources=$(BASEDIR)/tools/scansources
add_files=$(BASEDIR)/tools/add_files
set_mkisofs_opts=$(BASEDIR)/tools/set_mkisofs_opts
strip_nonus_bin=$(BASEDIR)/tools/strip-nonUS-bin
add_secured=$(BASEDIR)/tools/add_secured

BDIR=$(TDIR)/$(CODENAME)-$(ARCH)
ADIR=$(APTTMP)/$(CODENAME)-$(ARCH)
SDIR=$(TDIR)/$(CODENAME)-src

FIRSTDISKS=CD1 
ifdef FORCENONUSONCD1
FIRSTDISKS=CD1 CD1_NONUS
forcenonusoncd1=1
else
forcenonusoncd1=0
endif

## DEBUG STUFF ##

PrintVars:
	@num=1; \
	DATE=`date +%Y%m%d` ; \
	echo BINDISKINFO: ; \
        echo $(BINDISKINFO) ; \
	echo SRCDISKINFO: ; \
        echo $(SRCDISKINFO) ; \
	echo BINDISKINFOND: ; \
        echo $(BINDISKINFOND) ; \
	echo SRCDISKINFOND: ; \
        echo $(SRCDISKINFOND) ; \
	echo BINVOLID: ; \
        echo $(BINVOLID) ; \
	echo SRCVOLID: ; \
        echo $(SRCVOLID) ; \

## CHECKS ##

# Basic checks in order to avoid problems
ok=true
ifndef TDIR
ok=false
endif
ifndef BASEDIR
ok=false
endif
ifndef MIRROR
ok=false
endif
ifndef ARCH
ok=false
endif
ifndef CODENAME
ok=false
endif
ifndef OUT
ok=false
endif
# Never use NONFREE and EXTRANONFREE at the same time
ifdef NONFREE
ifdef EXTRANONFREE
ok=false
endif
endif
# If we have FORCENONUSONCD1 set, we must also have NONUS set
ifdef FORCENONUSONCD1
ifndef NONUS
ok=false
endif
endif
# If we do jigdo, we need a command and a URL. If not, make sure we won't.
ifneq "$(DOJIGDO)" "0"
ifndef JIGDOCMD
ok=false
endif
ifndef JIGDOTEMPLATEURL
ok=false
endif
else
export JIGDOCMD=false
endif

default:
	@echo "Please refer to the README file for more information"
	@echo "about the different targets available."

ok:
	@$(ok) || (echo \
	 "ERROR: Bad configuration. Please edit CONF.sh and source it ..." \
	 && false)

## INITIALIZATION ##

# Creation of the directories needed
init: ok $(TDIR) $(BDIR) $(SDIR) $(ADIR)
$(TDIR):
	$(Q)mkdir -p $(TDIR)
$(BDIR):
	$(Q)mkdir -p $(BDIR)
$(SDIR):
	$(Q)mkdir -p $(SDIR)
$(ADIR):
	$(Q)mkdir -p $(ADIR)
	$(Q)mkdir -p $(ADIR)/apt-ftparchive-db

## CLEANINGS ##

# CLeans the current arch tree (but not packages selection info)
clean: ok bin-clean src-clean
bin-clean:
	$(Q)-rm -rf $(BDIR)/CD[1234567890]
	$(Q)-rm -rf $(BDIR)/*_NONUS
	$(Q)-rm -f $(BDIR)/*.filelist*
	$(Q)-rm -f  $(BDIR)/packages-stamp $(BDIR)/bootable-stamp \
	         $(BDIR)/upgrade-stamp
src-clean:
	$(Q)-rm -rf $(SDIR)/CD[1234567890]
	$(Q)-rm -rf $(SDIR)/*_NONUS
	$(Q)-rm -rf $(SDIR)/sources-stamp

# Completely cleans the current arch tree
realclean: distclean
distclean: ok bin-distclean src-distclean
bin-distclean:
	$(Q)-rm -rf $(BDIR)
	$(Q)-rm -rf $(ADIR)
src-distclean:
	$(Q)-rm -rf $(SDIR)


## STATUS and APT ##

# Regenerate the status file with only packages that
# are of priority standard or higher
status: init $(ADIR)/status
$(ADIR)/status:
	@echo "Generating a fake status file for apt-get and apt-cache..."
	$(Q)zcat $(MIRROR)/dists/$(CODENAME)/main/binary-$(ARCH)/Packages.gz | \
	perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; \
	               print if (/^Priority: (required|important|standard)/m or \
		       /^Section: base/m);' \
	> $(ADIR)/status
	# Updating the apt database
	$(Q)$(apt) update
	#
	# Checking the consistence of the standard system
	# If this does fail, then launch make correctstatus
	#
	$(Q)$(apt) check || $(MAKE) correctstatus

# Only useful if the standard system is broken
# It tries to build a better status file with apt-get -f install
correctstatus: status apt-update
	# You may need to launch correctstatus more than one time
	# in order to correct all dependencies
	#
	# Removing packages from the system :
	$(Q)set -e; \
	for i in `$(apt) deselected -f install`; do \
		echo $$i; \
		perl -i -000 -ne "print unless /^Package: \Q$$i\E/m" \
		$(ADIR)/status; \
	done
	#
	# Adding packages to the system :
	$(Q)set -e; \
	for i in `$(apt) selected -f install`; do \
	  echo $$i; \
	  $(apt) cache dumpavail | perl -000 -ne \
	      "s/^(Package: .*)\$$/\$$1\nStatus: install ok installed/m; \
	       print if /^Package: \Q$$i\E\s*\$$/m;" \
	       >> $(ADIR)/status; \
	done
	#
	# Showing the output of apt-get check :
	$(Q)$(apt) check

apt-update: status
	@echo "Apt-get is updating his files ..."
	$(Q)$(apt) update


## GENERATING LISTS ##

# Deleting the list only
deletelist: ok
	$(Q)-rm $(BDIR)/rawlist
	$(Q)-rm $(BDIR)/list

# Generates the list of packages/files to put on each CD
list: bin-list src-list

# Generate the listing of binary packages
bin-list: ok apt-update genlist $(BDIR)/1.packages
$(BDIR)/1.packages:
	@echo "Dispatching the packages on all the CDs ..."
	$(Q)$(list2cds) $(BDIR)/list $(SIZELIMIT)
ifdef FORCENONUSONCD1
	$(Q)set -e; \
	 for file in $(BDIR)/*.packages; do \
	    newfile=$${file%%.packages}_NONUS.packages; \
	    cp $$file $$newfile; \
	    $(strip_nonus_bin) $$file $$file.tmp; \
	    if (cmp -s $$file $$file.tmp) ; then \
	        rm -f $$file.tmp $$newfile ; \
	    else \
	        echo Splitting non-US packages: $$file and $$newfile ; \
	        mv -f $$file.tmp $$file; \
	    fi ;\
	done
endif

# Generate the listing for sources CDs corresponding to the packages included
# in the binary set
src-list: bin-list $(SDIR)/1.sources
$(SDIR)/1.sources:
	@echo "Dispatching the sources on all the CDs ..."
	$(Q)$(cds2src) $(SIZELIMIT)
ifdef FORCENONUSONCD1
	$(Q)set -e; \
	 for file in $(SDIR)/*.sources; do \
	    newfile=$${file%%.sources}_NONUS.sources; \
	    cp $$file $$newfile; \
	    grep -v non-US $$file >$$file.tmp; \
	    if (cmp -s $$file $$file.tmp) ; then \
	        rm -f $$file.tmp $$newfile ; \
	    else \
	        echo Splitting non-US sources: $$file and $$newfile ; \
	        mv -f $$file.tmp $$file; \
	    fi ;\
	done
endif

# Generate the complete listing of packages from the task
# Build a nice list without doubles and without spaces
genlist: ok $(BDIR)/list
$(BDIR)/list: $(BDIR)/rawlist
	@echo "Generating the complete list of packages to be included ..."
	$(Q)perl -ne 'chomp; next if /^\s*$$/; \
	          print "$$_\n" if not $$seen{$$_}; $$seen{$$_}++;' \
		  $(BDIR)/rawlist \
		  > $(BDIR)/list

# Build the raw list (cpp output) with doubles and spaces
$(BDIR)/rawlist:
ifdef FORCENONUSONCD1
	$(Q)$(apt) cache dumpavail | \
		grep-dctrl -FSection -n -sPackage -e '^(non-US|non-us/main)' - | \
		sort | uniq > $(BDIR)/Debian_$(CODENAME)_nonUS
endif
	$(Q)if [ -x "`which debootstrap`" ]; then \
		debootstrap --arch $(ARCH) --print-debs $(CODENAME) \
		| tr ' ' '\n' >>$(BDIR)/rawlist; \
	fi
	$(Q)perl -npe 's/\@ARCH\@/$(ARCH)/g' $(TASK) | \
	 cpp -nostdinc -nostdinc++ -P -undef -D ARCH=$(ARCH) -D ARCH_$(ARCH) \
	     -U $(ARCH) -U i386 -U linux -U unix \
	     -DFORCENONUSONCD1=$(forcenonusoncd1) \
	     -I $(BASEDIR)/tasks -I $(BDIR) - - >> $(BDIR)/rawlist

## DIRECTORIES && PACKAGES && INFOS ##

# Create all the needed directories for installing packages (plus the
# .disk directory)
tree: bin-tree src-tree
bin-tree: ok bin-list $(BDIR)/CD1/debian
$(BDIR)/CD1/debian:
	@echo "Adding the required directories to the binary CDs ..."
	$(Q)set -e; \
	 for i in $(BDIR)/*.packages; do \
		dir=$${i%%.packages}; \
		dir=$${dir##$(BDIR)/}; \
		dir=$(BDIR)/CD$$dir; \
		mkdir -p $$dir; \
		$(add_dirs) $$dir; \
	done

src-tree: ok src-list $(SDIR)/CD1/debian
$(SDIR)/CD1/debian:
	@echo "Adding the required directories to the source CDs ..."
	$(Q)set -e; \
	 for i in $(SDIR)/*.sources; do \
		dir=$${i%%.sources}; \
		dir=$${dir##$(SDIR)/}; \
		dir=$(SDIR)/CD$$dir; \
		mkdir -p $$dir; \
		$(add_dirs) $$dir; \
	done

# CD labels / volume ids / disk info
infos: bin-infos src-infos
bin-infos: bin-tree $(BDIR)/CD1/.disk/info
$(BDIR)/CD1/.disk/info:
	@echo "Generating the binary CD labels and their volume ids ..."
	$(Q)set -e; \
	 nb=`ls -l $(BDIR)/?.packages | wc -l | tr -d " "`; num=0;\
	 DATE=`date +%Y%m%d`; \
	for i in $(BDIR)/*.packages; do \
		num=$${i%%.packages}; num=$${num##$(BDIR)/}; \
		dir=$(BDIR)/CD$$num; \
		echo -n $(BINDISKINFO) | sed 's/_NONUS//g' > $$dir/.disk/info; \
		echo '#define DISKNAME ' $(BINDISKINFOND) | sed 's/_NONUS//g' \
					> $$dir/README.diskdefines; \
		echo '#define TYPE  binary' \
					>> $$dir/README.diskdefines; \
		echo '#define TYPEbinary  1' \
					>> $$dir/README.diskdefines; \
		echo '#define ARCH ' $(ARCH) \
					>> $$dir/README.diskdefines; \
		echo '#define ARCH'$(ARCH) ' 1' \
					>> $$dir/README.diskdefines; \
		echo '#define DISKNUM ' $$num | sed 's/_NONUS//g' \
					>> $$dir/README.diskdefines; \
		echo '#define DISKNUM'$$num ' 1' | sed 's/_NONUS//g' \
					>> $$dir/README.diskdefines; \
		echo '#define TOTALNUM ' $$nb \
					>> $$dir/README.diskdefines; \
		echo '#define TOTALNUM'$$nb ' 1' \
					>> $$dir/README.diskdefines; \
		echo -n $(BINVOLID) > $(BDIR)/$${num}.volid; \
		$(set_mkisofs_opts) bin $$num > $(BDIR)/$${num}.mkisofs_opts; \
	done
src-infos: src-tree $(SDIR)/CD1/.disk/info
$(SDIR)/CD1/.disk/info:
	@echo "Generating the source CD labels and their volume ids ..."
	$(Q)set -e; \
	 nb=`ls -l $(SDIR)/?.sources | wc -l | tr -d " "`; num=0;\
	 DATE=`date +%Y%m%d`; \
	for i in $(SDIR)/*.sources; do \
		num=$${i%%.sources}; num=$${num##$(SDIR)/}; \
		dir=$(SDIR)/CD$$num; \
		echo -n $(SRCDISKINFO) | sed 's/_NONUS//g' > $$dir/.disk/info; \
		echo '#define DISKNAME ' $(SRCDISKINFOND) | sed 's/_NONUS//g' \
					> $$dir/README.diskdefines; \
		echo '#define TYPE  source' \
					>> $$dir/README.diskdefines; \
		echo '#define TYPEsource  1' \
					>> $$dir/README.diskdefines; \
		echo '#define ARCH ' $(ARCH) \
					>> $$dir/README.diskdefines; \
		echo '#define ARCH'$(ARCH) ' 1' \
					>> $$dir/README.diskdefines; \
		echo '#define DISKNUM ' $$num | sed 's/_NONUS//g' \
					>> $$dir/README.diskdefines; \
		echo '#define DISKNUM'$$num ' 1' | sed 's/_NONUS//g' \
					>> $$dir/README.diskdefines; \
		echo '#define TOTALNUM ' $$nb \
					>> $$dir/README.diskdefines; \
		echo '#define TOTALNUM'$$nb ' 1' \
					>> $$dir/README.diskdefines; \
		echo -n $(SRCVOLID) > $(SDIR)/$${num}.volid; \

=== debian/changelog ===
debian-cd (2.2.13) unstable; urgency=low

  * Add jigdo generation support (see README).
  * Automatically add packages listed by local debootstrap. Closes: #131820
  * Adapted to new s390 boot-floppies 3.0.19 directory structure (Stefan
    Gybas <sgybas@debian.org>).
  * Updated boot-i386 for the boot-floppies 3.0.19.
  * Don't include the base-images-* directories on the CD. They
    are meant for people wishing to install by floppy (who download the
    floppy images from the net).
  * Corrected the priority to match the priority given in the override file.
  * CDs with .disk/kernel_installable have the disks-<arch> directories
    and those with .disk/base_installable have all the packages required
    by debootstrap.
  * Updated base-woody with debootstrap 0.1.17. Closes: #138357

 -- Raphael Hertzog <hertzog@debian.org>  Sat, 16 Mar 2002 19:53:41 +0100

debian-cd (2.2.12) unstable; urgency=low

  * Get it right this time with the MULTIBOOT test ... Closes: #127234
  * Correct spelling mistake in README.devel. Closes: #127726
  * Make the log output more consistent and offer the possibility
    to not force the inclusion of recommended/suggested packages.
    Thanks to Petter Reinholdtsen for the patches.
    Closes: #127964, #127968
  * Undef some automatic variable substitution (like i386)
    of cpp causing problems while generating tasks files. Closes: #129044
    Thanks again to Petter Reinholdsten.
  * Don't fail if Contents-$ARCH files are missing. Closes: #129166

 -- Raphael Hertzog <hertzog@debian.org>  Sat, 29 Dec 2001 19:57:23 +0100

debian-cd (2.2.11) unstable; urgency=medium

  * Changed "==" test by "=" test that works with ash also. Closes: #125727
  * Corrected the rules files to remove the .#* files of CVS merges.
    Closes: #125728
  * Corrected the documentation. Closes: #125729
  * Complains about missing Release files. Closes: #126076

 -- Raphael Hertzog <hertzog@debian.org>  Sun, 16 Dec 2001 04:34:03 +0100

debian-cd (2.2.10) unstable; urgency=low

  * first test of multi-boot cdimage for i386 disk #1
    You must export MULTIBOOT="yes" in CONF.sh  to enable this feature. -jwest
  * Removed "ide" boot floppy's flavor. Closes: #120415
  * Added support for s390 (Jochen Rhrig <jr@debian.org>).
  * Documentation about the fact the environment variables may
    pollute your environment after a debian-cd run. Closes: #123289

 -- Raphael Hertzog <hertzog@debian.org>  Mon, 26 Nov 2001 18:21:50 +0100

debian-cd (2.2.9) unstable; urgency=low

  * Added i386 boot blocks for udam100-ext3 to disk 5 -jwest
  * Added i386 boot blocks for reiserfs to disk 6 - jwest
  * Drop support of slink. Drop support of dpkg-multicd.
  * Uses apt-ftparchive and no more dpkg-scan{packages,sources}.
  * Does use the extra override file. Closes: #113794
  * Remove the use of unzip in boot-alpha. Nobody should use unzip...
  * Update yaboot.conf and ofboot.b to conform to current (1.3.4) yaboot (powerpc).
  * If using BOOTDISK= pick up docs from there also (Richard Hirst).
  * Synced tasks/base-woody with debootstrap 0.1.15.8.
    Closes: #119099
  * Add kludgy yaboot.conf for potato's broken yaboot.
  * ia64, only first disk is bootable, and use symlinks in /install
    to save space.  rescue.bin is 10MB on ia64.  (Richard Hirst)

 -- Raphael Hertzog <hertzog@debian.org>  Sun, 16 Sep 2001 14:57:22 +0200

debian-cd (2.2.8) unstable; urgency=low

  * Be less restrictive on non-US section name (ie accepts non-us too).
  * Add support for ia64 (Richard Hirst).  Closes: #110553.
  * Update the "Components" field of the Release files. Was
    causing a bug in debootstrap.
  * Add support for hppa (Richard Hirst).
  * Removed the last reference to unzip. No more references to lha
    either. So debian-cd can go in main.
  * Changes for powerpc were made by Ethan Benson. Closes: #104333

 -- Raphael Hertzog <hertzog@debian.org>  Sun, 19 Aug 2001 13:42:27 +0200

debian-cd (2.2.7) unstable; urgency=low

  * Minor fix in tools/woody/installtools.sh
  * Disabled the secured stuff by default. Make it configurable
    with a environment variable.
  * Various other little changes (in particular wrt LOCAL handling).

 -- Raphael Hertzog <hertzog@debian.org>  Tue, 24 Jul 2001 18:56:33 +0200

debian-cd (2.2.6) unstable; urgency=medium

  * Updated tasks/base-woody to be in sync with debootstrap 0.1.15.
  * Improved documentation about Official images. Closes: #101578
  * Build woody CD set by default now. Updated CONF.sh accordingly.
  * Use Digest::MD5 instead of MD5. Depends on libdigest-md5-perl
    instead of "libdigest-md5-perl | libmd5-perl". Closes: #104184

 -- Raphael Hertzog <hertzog@debian.org>  Tue, 19 Jun 2001 00:43:04 +0200

debian-cd (2.2.5) unstable; urgency=low

  * Remove (obsolete) -a from mkhybrid call. Changed mkhybrid to mkisofs
    since mkhybrid has been superseded by mkisofs. Closes: #97439
  * Only includes latest version of a package if a newer version
    is provided in a local repository.
  * Includes on CD1 packages needed by debootstrap. Closes: #100353

 -- Raphael Hertzog <hertzog@debian.org>  Sat, 19 May 2001 15:15:29 +0200

debian-cd (2.2.4) unstable; urgency=medium

  * All (i386) CD's now have a different kernel from boot-disks.
  * Updated pi-makelist, now excludes all of the sparc live filesystem.
  * Added Recommends: debianutils because pi-makelist uses tempfile(1)
    since 2.2.3; also mentioned this in the debian-cd/YACS README.
  * Some minor updates/rewordings in CD's top-level README.
  * Typo. tools/add_dirs line #26 changed to if [ -n     --jwest
    Closes: #79902
  * Include a new interactive boot.bat. Closes: #83471
  * Corrected tools/apt-selection. Closes: #79903
  * Does correctly manage pools wrt Packages files. 
  * Now depends on grep-dctrl.
  * Now creates a $CODENAME-secured tree with Release and Release.gpg
    files from the archive. Closes: #93612
  * Some esthetic corrections to the Makefile.
  * Updated the popularity-contest file.


=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Raphael Hertzog <hertzog@debian.org>
Build-Depends-Indep: debhelper (>= 3)
Standards-Version: 3.5.2

Package: debian-cd
Architecture: all
Depends: perl, libdigest-md5-perl, sysutils, apt (>= 0.3.11.1), make, mkisofs | mkhybrid, lynx, grep-dctrl, apt-utils (>= 0.5.4), debootstrap
Recommends: hfsutils, debianutils (>= 1.6)
Suggests: palo (>= 0.94)
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.

=== debian/rules ===
#!/usr/bin/make -f
#-*- makefile -*-
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# Some lines taken from debmake, by Christoph Lameter.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DH_COMPAT=3

build: build-stamp
build-stamp:
	dh_testdir

	#CONFIGURE#
	# Add here commands to compile the package.
	#$(MAKE) 

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp install-stamp

	# Add here commands to clean up after the build process.
	#-#CLEAN#

	dh_clean

install: install-stamp
install-stamp: build-stamp
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	cp -r tools tasks data Makefile README README.devel build.sh \
              build_all.sh update-cd debian/debian-cd/usr/share/debian-cd/
	cp debian/CONF.sh debian/debian-cd/etc/debian-cd/conf.sh
	ln -sf /etc/debian-cd/conf.sh \
               debian/debian-cd/usr/share/debian-cd/CONF.sh
	find debian/debian-cd -name 'CVS' | xargs -r rm -rf
	find debian/debian-cd -name '.#*' | xargs -r rm -f
	find debian/debian-cd/usr/share/debian-cd/tools/boot \
	  \( -name 'boot-*' -o -name 'post-boot-*' \) -a \! -name '*.txt' \
	  -a \! -name '*.calc' |  xargs chmod 0755

	touch install-stamp

# Build architecture-dependent files here.
binary-arch: build install
# We have nothing to do by default.

# Build architecture-independent files here.
binary-indep: build install
#	dh_testversion
	dh_testdir
	dh_testroot
	dh_installdocs README*
	dh_installexamples
	dh_installmenu
#	dh_installemacsen
#	dh_installinit
	dh_installcron
	dh_installmanpages
#	dh_undocumented
	dh_installchangelogs
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	# You may want to make some executables suid here
#	dh_makeshlibs
	dh_installdeb
#	dh_perl 
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## debian-cd 2.2.17

=== Makefile ===
--- 
+++ 
@@ -24,17 +24,17 @@
 CAPCODENAME:=$(shell perl -e "print ucfirst("$(CODENAME)")")
 endif
 ifndef BINDISKINFO
-BINDISKINFO="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num ($$DATE)"
+export BINDISKINFO="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num ($$DATE)"
 endif
 ifndef SRCDISKINFO
-SRCDISKINFO="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num ($$DATE)"
+export SRCDISKINFO="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num ($$DATE)"
 endif
 # ND=No-Date versions for README
 ifndef BINDISKINFOND
-BINDISKINFOND="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num"
+export BINDISKINFOND="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) $(ARCH) Binary-$$num"
 endif
 ifndef SRCDISKINFOND
-SRCDISKINFOND="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num"
+export SRCDISKINFOND="Debian GNU/Linux $(DEBVERSION) \"$(CAPCODENAME)\" - $(OFFICIAL) Source-$$num"
 endif
 ifndef BINVOLID
 ifeq ($(ARCH),powerpc)
@@ -58,11 +58,26 @@
 ifndef HOOK
 HOOK=$(BASEDIR)/tools/$(CODENAME).hook
 endif
+ifneq "$(wildcard $(MIRROR)/dists/$(CODENAME)/main/disks-$(ARCH))" ""
 ifndef BOOTDISKS
 export BOOTDISKS=$(MIRROR)/dists/$(CODENAME)/main/disks-$(ARCH)
 endif
+endif
 ifndef DOJIGDO
 export DOJIGDO=0
+endif
+ifndef JIGDOSCRIPT
+JIGDOSCRIPT=$(BASEDIR)/tools/jigdo_header
+endif
+
+ifndef UDEB_INCLUDE
+# Netinst/businesscard CD should have udeb_include file by default
+ifeq ($(INSTALLER_CD),1)
+UDEB_INCLUDE=$(BASEDIR)/data/$(CODENAME)/$(ARCH)_businesscard_udeb_include
+endif
+ifeq ($(INSTALLER_CD),2)
+UDEB_INCLUDE=$(BASEDIR)/data/$(CODENAME)/$(ARCH)_netinst_udeb_include
+endif
 endif
 
 ## Internal variables  
@@ -80,6 +95,8 @@
 set_mkisofs_opts=$(BASEDIR)/tools/set_mkisofs_opts
 strip_nonus_bin=$(BASEDIR)/tools/strip-nonUS-bin
 add_secured=$(BASEDIR)/tools/add_secured
+md5sum=/usr/bin/md5sum.textutils
+fastsums=$(BASEDIR)/tools/fast_sums
 
 BDIR=$(TDIR)/$(CODENAME)-$(ARCH)
 ADIR=$(APTTMP)/$(CODENAME)-$(ARCH)
@@ -111,60 +128,49 @@
 	echo SRCVOLID: ; \
         echo $(SRCVOLID) ; \
 
-## CHECKS ##
-
-# Basic checks in order to avoid problems
-ok=true
-ifndef TDIR
-ok=false
-endif
-ifndef BASEDIR
-ok=false
-endif
-ifndef MIRROR
-ok=false
-endif
-ifndef ARCH
-ok=false
-endif
-ifndef CODENAME
-ok=false
-endif
-ifndef OUT
-ok=false
-endif
-# Never use NONFREE and EXTRANONFREE at the same time
-ifdef NONFREE
-ifdef EXTRANONFREE
-ok=false
-endif
-endif
-# If we have FORCENONUSONCD1 set, we must also have NONUS set
-ifdef FORCENONUSONCD1
-ifndef NONUS
-ok=false
-endif
-endif
-# If we do jigdo, we need a command and a URL. If not, make sure we won't.
-ifneq "$(DOJIGDO)" "0"
-ifndef JIGDOCMD
-ok=false
-endif
-ifndef JIGDOTEMPLATEURL
-ok=false
-endif
-else
-export JIGDOCMD=false
-endif
-
 default:
 	@echo "Please refer to the README file for more information"
 	@echo "about the different targets available."
 
+## CHECKS ##
+
+# Basic checks in order to avoid problems
 ok:
-	@$(ok) || (echo \
-	 "ERROR: Bad configuration. Please edit CONF.sh and source it ..." \
-	 && false)
+ifndef TDIR
+	@echo TDIR undefined -- set up CONF.sh; false
+endif
+ifndef BASEDIR
+	@echo BASEDIR undefined -- set up CONF.sh; false
+endif
+ifndef MIRROR
+	@echo MIRROR undefined -- set up CONF.sh; false
+endif
+ifndef ARCH
+	@echo ARCH undefined -- set up CONF.sh; false
+endif
+ifndef CODENAME
+	@echo CODENAME undefined -- set up CONF.sh; false
+endif
+ifndef OUT
+	@echo OUT undefined -- set up CONF.sh; false
+endif
+ifdef NONFREE
+ifdef EXTRANONFREE
+	@echo Never use NONFREE and EXTRANONFREE at the same time; false
+endif
+endif
+ifdef FORCENONUSONCD1
+ifndef NONUS
+	@echo If we have FORCENONUSONCD1 set, we must also have NONUS set; false
+endif
+endif
+ifneq "$(DOJIGDO)" "0"
+ifndef JIGDOCMD
+	@echo JIGDOCMD undefined -- set up CONF.sh; false
+endif
+else
+export JIGDOCMD=false
+endif
 
 ## INITIALIZATION ##
 
@@ -185,25 +191,26 @@
 # CLeans the current arch tree (but not packages selection info)
 clean: ok bin-clean src-clean
 bin-clean:
-	$(Q)-rm -rf $(BDIR)/CD[1234567890]
-	$(Q)-rm -rf $(BDIR)/*_NONUS
-	$(Q)-rm -f $(BDIR)/*.filelist*
-	$(Q)-rm -f  $(BDIR)/packages-stamp $(BDIR)/bootable-stamp \
-	         $(BDIR)/upgrade-stamp
+	$(Q)rm -rf $(BDIR)/CD[1234567890]
+	$(Q)rm -rf $(BDIR)/*_NONUS
+	$(Q)rm -f $(BDIR)/*.filelist*
+	$(Q)rm -f  $(BDIR)/packages-stamp $(BDIR)/bootable-stamp \
+	         $(BDIR)/upgrade-stamp $(BDIR)/secured-stamp
 src-clean:
-	$(Q)-rm -rf $(SDIR)/CD[1234567890]
-	$(Q)-rm -rf $(SDIR)/*_NONUS
-	$(Q)-rm -rf $(SDIR)/sources-stamp
+	$(Q)rm -rf $(SDIR)/CD[1234567890]
+	$(Q)rm -rf $(SDIR)/*_NONUS
+	$(Q)rm -rf $(SDIR)/sources-stamp $(SDIR)/secured-stamp
 
 # Completely cleans the current arch tree
 realclean: distclean
 distclean: ok bin-distclean src-distclean
 bin-distclean:
-	$(Q)-rm -rf $(BDIR)
-	$(Q)-rm -rf $(ADIR)
+	$(Q)rm -rf $(BDIR)
+	$(Q)rm -rf $(ADIR)
+	$(Q)rm -rf $(TDIR)/jigdofilelist
 src-distclean:
-	$(Q)-rm -rf $(SDIR)
-
+	$(Q)rm -rf $(SDIR)
+	$(Q)rm -rf $(TDIR)/jigdofilelist
 
 ## STATUS and APT ##
 
@@ -212,11 +219,15 @@
 status: init $(ADIR)/status
 $(ADIR)/status:
 	@echo "Generating a fake status file for apt-get and apt-cache..."
-	$(Q)zcat $(MIRROR)/dists/$(CODENAME)/main/binary-$(ARCH)/Packages.gz | \
-	perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; \
+	$(Q)if [ "$(INSTALLER_CD)" = "1" -o "$(INSTALLER_CD)" = "2" ];then \
+		:> $(ADIR)/status ; \
+	else \
+		zcat $(MIRROR)/dists/$(CODENAME)/main/binary-$(ARCH)/Packages.gz | \
+		perl -000 -ne 's/^(Package: .*)$$/$$1\nStatus: install ok installed/m; \
 	               print if (/^Priority: (required|important|standard)/m or \
 		       /^Section: base/m);' \
-	> $(ADIR)/status
+		> $(ADIR)/status ; \
+	fi
 	# Updating the apt database
 	$(Q)$(apt) update
 	#
@@ -322,11 +333,11 @@
 $(BDIR)/rawlist:
 ifdef FORCENONUSONCD1
 	$(Q)$(apt) cache dumpavail | \
-		grep-dctrl -FSection -n -sPackage -e '^(non-US|non-us/main)' - | \
+		grep-dctrl -FSection -n -sPackage -e '^(non-US|non-us)' - | \
 		sort | uniq > $(BDIR)/Debian_$(CODENAME)_nonUS
 endif
-	$(Q)if [ -x "`which debootstrap`" ]; then \
-		debootstrap --arch $(ARCH) --print-debs $(CODENAME) \
+	$(Q)if [ -x "/usr/sbin/debootstrap" -a _$(INSTALLER_CD) != _1 ]; then \
+		/usr/sbin/debootstrap --arch $(ARCH) --print-debs $(CODENAME) \
 		| tr ' ' '\n' >>$(BDIR)/rawlist; \
 	fi
 	$(Q)perl -npe 's/\@ARCH\@/$(ARCH)/g' $(TASK) | \
@@ -406,23 +417,3 @@
 	for i in $(SDIR)/*.sources; do \
 		num=$${i%%.sources}; num=$${num##$(SDIR)/}; \
 		dir=$(SDIR)/CD$$num; \
-		echo -n $(SRCDISKINFO) | sed 's/_NONUS//g' > $$dir/.disk/info; \
-		echo '#define DISKNAME ' $(SRCDISKINFOND) | sed 's/_NONUS//g' \
-					> $$dir/README.diskdefines; \
-		echo '#define TYPE  source' \
-					>> $$dir/README.diskdefines; \
-		echo '#define TYPEsource  1' \
-					>> $$dir/README.diskdefines; \
-		echo '#define ARCH ' $(ARCH) \
-					>> $$dir/README.diskdefines; \
-		echo '#define ARCH'$(ARCH) ' 1' \
-					>> $$dir/README.diskdefines; \
-		echo '#define DISKNUM ' $$num | sed 's/_NONUS//g' \
-					>> $$dir/README.diskdefines; \
-		echo '#define DISKNUM'$$num ' 1' | sed 's/_NONUS//g' \
-					>> $$dir/README.diskdefines; \
-		echo '#define TOTALNUM ' $$nb \
-					>> $$dir/README.diskdefines; \
-		echo '#define TOTALNUM'$$nb ' 1' \
-					>> $$dir/README.diskdefines; \
-		echo -n $(SRCVOLID) > $(SDIR)/$${num}.volid; \

=== debian/changelog ===
debian-cd (2.2.17) unstable; urgency=low

  * Removed debian/conffiles (useless with debhelper 4).
  * Added aptitude on netinst CD (but not on businesscard CD).
    Closes: #220125, #219986
    It is already on CD1 of a normal CD set.
  * Kenshi Muto
    - Add jfbterm, unifont into forcd1, d-i+kernel (second stage of
      debian-installer needs them).
    - Add console-cyrillic, console-terminus, hotplug into forcd1,
      d-i+kernel.
  * Joey Hess
    - Add "expert" mode to isolinux.cfg for sarge.
    - Remove pump-udeb from all udeb_includes; netcfg depends on and
      uses dhcp-client-udeb.
    - Add appropriate kernel-pcmcia-modules package to
      debian-installer+kernel task for i386.
    - Update the yaboot boot.msg to match the one in d-i cvs.
    - Update the yaboot.conf to add expert and expert-safe boot modes.
    - Link the d-i INSTALLATION-HOWTO into doc/, if it exists.
    - Add my exclude_udebs lists, for general and i386, and modify
      generate_di_list to not include udebs from those lists onto the
      cdrom, to save space on the netinst cds. Closes: #215469
    - Use the d-i docs in sid instead of the woody boot floppies docs.
    - Add pcmcia-cs-udeb to sarge's i386_netinst_udeb_include, to support
      pcmcia installs.
    - Remove console-keymaps from all udeb_includes; they are included
      on the cdrom initrds.
    - Switch from netcfg-static/dhcp to just netcfg.
    - Split udeb_includes for businesscard and netinst; netinst does not
      need choose-mirror, while businesscard does.
    - Add wireless-tool-udeb to udeb_include for i386 and powerpc netinst
      and businesscard images.
    - Add pcmcia-cs onto the generate-di+k_list, now that is is not
      autoinstalled by debootstrap.
    - Document vga=771 boot option for laptops with screen problems.
    - Add the debian-edu udebs to the exclude list for netinst CDs, and
      remove the deleted di-utils-devicefiles.
    - Update boot/sarge/boot-i386 to use the new d-i image names.
    - Use d-i boot screens from the debian-cd_info.tar.gz. 
      Closes: #220612, #221186
    - Remove the netboot initrd from netinst CDs, since d-i builds a mini-iso
      with this initrd on it, and since the d-i help screen does not mention
      the net type.
    - Add xfsprogs and reiserfsprogs to generate_di+k_list.
    - Add lilo as well; it's not autoinstalled by debootstrap, but
      lilo-installer still uses it.
    - Increase the i386 isolinux ramdisk size to 10 mb; it's grown due to
      translatons and all the scsi drivers.
    - Drop lowmemcheck from the CD; it is in the initrd.
    - Add wireless-tools to generate_d-i+k_list
    - Remove the old partitioner from the CD for i386. (This should also be
      done for other arches for which it is not default)
    - Include all the powerpc kernels that d-i's base-installer currently
      could try to install on the CD.
    - Try to include some sparc kernels on the CD; it's probably better than
      including none..
    - Revamped the README.html, removing the old manual apt setup
      instructions, various references to woody, fixing the link to the LDP
      home page, dropping reference to the basically dead non-us section,
      removing confusing references to non-free being on the CD, dropping
      references to dselect, etc.
    - Fix layout of README.txt, adding missing <p>'s after headings.
    - Drop README.mirrors and README.non-US from the CDs.
  * Steve Langasek
    - Add fdisk-udeb to the list of needed debs for alpha
    - Use /dev/ram as the root device for aboot (alpha)
  * Petter Reinholdtsen
    - Updated tasks/README with new location of popularity-contest results.
    - Regenereated tasks/popularity-contest-sarge based on the current
      data.
    - Avoid acorn-fdisk, cfdisk-utf8 and lots of kernels on the first CD.
      It should be enough with one kernel package on the first CD.
    - Make generated debian-installer list easier to read by adding
      arch info at the end of an #ifdef block.
  * Santiago Garcia
    - Add DI_CODENAME variable make it posible to build cds with a special
      debian-installer version.
    - Make Makefile remove dedication files except for current version.
    - Update debian-installer.* tasks
    - Add hppa kernels to generate_di+k_list
    - Add sarge boot scripts for hppa

 -- Raphael Hertzog <hertzog@debian.org>  Wed, 20 Aug 2003 20:17:06 +0200

debian-cd (2.2.16) unstable; urgency=low

  * Updated standards-version to 3.6.0.
  * Use debhelper 4 (build-depends on it, updated DH_COMPAT).
  * WARNING: potato is now mostly unsupported, some cruft has been
    removed that may have been useful for generating potato CDs.
  * Added debian-installer support. debian-installer is automatically
    used if $MIRROR/dists/$CODENAME/main/debian-installer exists.
    (however you have to require the inclusion of the udeb via the
    task mechanism, cf tasks/debian-installer for the current list)
  * Added all files for sarge (in tasks/ data/ and tools/).
  * Updated isolinux.bin from syslinux 1.75-1.
  * Tollef Fog Heen:
    - Make it possible to exclude contrib from the CDs. Useful if you only
      have a mirror of main.
    - The names of the bootable images have changed on
      people.d.o/~tfheen/d-i/images/daily, update download scripts to reflect
      that.
  * Petter Reinholdtsen:
    - Add CONTRIB flag to debian/CONF.sh.
    - Add support for BASE_INCLUDE and BASE_EXCLUDE, making files
      cdrom/.disk/base_include and .../base_exclude used by
      debian-installer.
    - Document BOOTDISKS.
    - Make disk number available in tools/add-bin-doc.
    - In woody, keep the time stamp of smb.bin when copying it to CD.
    - Add support for UDEB_INCLUDE and UDEB_EXCLUDE, making files
      cdrom/.disk/udeb_include and .../udeb_exclude used by
      debian-installer.
  * Apply patch from Petter Reinholdtsen for inclusion of
    Recommends/Suggests from the base system. Closes: #106903


=== debian/control ===
Source: debian-cd
Section: admin
Priority: extra
Maintainer: Raphael Hertzog <hertzog@debian.org>
Build-Depends-Indep: debhelper (>= 4)
Standards-Version: 3.6.0

Package: debian-cd
Architecture: all
Depends: perl, cpp, libdigest-md5-perl, sysutils, apt (>= 0.3.11.1), make, mkisofs | mkhybrid, lynx, grep-dctrl, apt-utils (>= 0.5.4), debootstrap, bc
Recommends: hfsutils, debianutils (>= 1.6), jigdo-file (>= 0.7.0)
Suggests: palo (>= 0.94), binutils-multiarch
Description: Tools for building (Official) Debian CD set
 Debian-cd is the official tool for building Debian CD set since the potato
 release. It was formerly called YACS (for Yet Another CD Script).
 .
 Its goal is to facilitate the creation of customized Debian CD set.
